/* --------------------------------------------------------------------------------
 #
 #	4DPlugin.c
 #	source generated by 4D Plugin Wizard
 #	Project : QTPlay
 #	author : Thomas Maul, 4D Germany
 #	03.07.2005
 #
 # --------------------------------------------------------------------------------*/



#include "QTPlayextern.h"
#include "4DPlugin.h"

void PluginMain( long selector, PA_PluginParameters params )
{
	switch( selector )
	{
		case kInitPlugin :
			InitPlugin();
			break;

		case kDeinitPlugin :
			DeinitPlugin();
			break;

// --- QTSimple

		case 2 :
			QTPlayMovie( params );
			break;

		case 1 :
			QTPlayStop( );
			break;

// --- QTControl

		case 3 :
			QTSetMovie( params );
			break;


		case 4 :
			QTSetControl( params );
			break;

		case 5 :
			QTGetControl( params );
			break;

// --- External areas

		case 6 :
			QTContainer( params );
			break;

#if __NextVersion__
		case 7 :
			QTGetTag( params );
			break;
#endif
	}
}

void InitPlugin()
{
	QT_Init();
}

void DeinitPlugin()
{
	QT_DeInit();
}

// ----------------------------------- QTSimple -----------------------------------


void QTPlayMovie( PA_PluginParameters params )
{
	long Pfad_len;
	char Pfad[32000];
	long returnValue = 0;

	Pfad_len = PA_GetTextParameter( params, 1, Pfad );
	// --- write the code of QTPlayMovie here...
	returnValue = PlayFileWithQuickTime(Pfad, Pfad_len);
	PA_ReturnLong( params, returnValue );
}

void QTPlayStop( void )
{
	// --- write the code of QTPlayStop here...
	StopPlayFileWithQuickTime();
}

// ----------------------------------- QTControl ----------------------------------


void QTSetMovie( PA_PluginParameters params )
{
	long Pfad_len;
	char Pfad[32000];
	long returnValue=0;
	void *Area;

	Area = (void *) PA_GetLongParameter( params, 1 );
	Pfad_len = PA_GetTextParameter( params, 2, Pfad );

	returnValue = QT_SetMovie(Area, Pfad, Pfad_len);

	PA_ReturnLong( params, returnValue );
}

void QTSetControl( PA_PluginParameters params )
{
	long returnValue=0, command, value;
	void *Area;

	Area = (void *) PA_GetLongParameter( params, 1 );
	command = PA_GetLongParameter( params, 2 );
	value = PA_GetLongParameter( params, 3 );

	returnValue = QT_SetControl(Area, command, value);

	PA_ReturnLong( params, returnValue );
}

void QTGetControl( PA_PluginParameters params )
{
	long returnValue=0, command, value=0;
	void *Area;

	Area = (void *) PA_GetLongParameter( params, 1 );
	command = PA_GetLongParameter( params, 2 );

	returnValue = QT_GetControl(Area, command, &value);
	PA_SetLongParameter(params, 3, value);

	PA_ReturnLong( params, returnValue );
}


#if __NextVersion__
void QTGetTag( PA_PluginParameters params )
{
	long Pfad_len;
	char Pfad[32000];
	long returnValue=0;
	void *Area;

	Area = (void *) PA_GetLongParameter( params, 1 );

	returnValue = QT_GetID3Tags(Area, PA_GetVariableParameter ( params, 2 ), PA_GetVariableParameter ( params, 3 ));

	PA_ReturnLong( params, returnValue );
}
#endif
// -------------------------------- External Areas --------------------------------


void QTContainer( PA_PluginParameters params )
{
	PA_AreaEvent event;
//	PA_PluginProperties props;
	void * privateData;
//	void * myptr;
	PA_DragAndDropInfo dropInfo;

#if VERSIONWIN
	HDC         hdc;
	HBRUSH      hbrush;
	RECT         rect;
	HGDIOBJ   old;
	HFONT hf;
	char szTitle[] = "QuickTime Container - Tech Note 2005, Thomas Maul, 4D Germany";
#else
	char szTitle[] = "\pQuickTime Container - Tech Note 2005, Thomas Maul, 4D Germany";

#endif	
	PA_Rect   areaRect;



	event = PA_GetAreaEvent( params );
	
	switch ( event )
	{
	// --- Initialisation
		case eAE_InitAdvancedProperties :
			QTArea_PreInit( params );  //  bug?? ACI0026601
			//  does not work...   
			//PA_DontTakeEvent( params );  // sho eAE_InitArea will still be called.
		
			break;

		case eAE_InitArea :
			QTArea_Init( params );
			//privateData = (void*) QTArea_Init(); 
			//PA_SetAreaReference( params, privateData );		
			break;

	// --- Deinitialisation
		case eAE_Deinit :
			privateData = PA_GetAreaReference( params );
			QTArea_DeInit(privateData);
			break;

		case eAE_EndExecutionCycle:
			QTArea_Execution(params);
			break;

	// --- Update in layout editor
		case eAE_DesignUpdate :
			areaRect = PA_GetAreaRect( params );
			#if VERSIONWIN
				hdc = (HDC) PA_GetUpdateHDC();
				MyPA_RectToRECT(areaRect, &rect);
				hbrush = CreateSolidBrush( 0 );
				old = SelectObject( hdc, hbrush );
				//FrameRect( hdc, &rect, hbrush );
				FillRect(hdc, &rect, GetStockObject(WHITE_BRUSH));
				SelectObject( hdc, old );
				hf = GetStockObject(DEFAULT_GUI_FONT);
				old = SelectObject( hdc, hf );
				rect.top += 20;
				rect.left +=5;
				TextOut(hdc, rect.left, rect.top, szTitle, strlen(szTitle));
				SelectObject( hdc, old ); 
			#else 
				MoveTo(areaRect.fLeft+5 , areaRect.fTop + 20);
				DrawString(szTitle);
			#endif
			PA_CustomizeDesignMode( params );
			break;

	// --- Handle Drop of 4D objects on the area
		case eAE_AllowDrop :
			dropInfo = PA_GetDragAndDropInfo( params );
			// Accept or refuse drop of this object on area
			// PA_AllowDrop( params, 1 );
				PA_DontTakeEvent( params );
			break;

		case eAE_Drag :
			//PA_GetDragPositions( params, &areaRect, &x, &y );
			// Handle customized dragging feedback here
			//PA_CustomizeDragOver( params );
				PA_DontTakeEvent( params );
			break;

		case eAE_Drop :
			//dropInfo = PA_GetDragAndDropInfo( params );
			// Handle drop of object here
				PA_DontTakeEvent( params );
			break;

	// --- Key down event
		case eAE_KeyDown :
			//key = PA_GetKey( params );
			// Handle key down event here
				PA_DontTakeEvent( params );
			break;

	// --- Mouse down event
		case eAE_MouseDown :
			QT_DoClick(params);
			break;

		case eAE_MouseWheel :
			// to be called when AreaEvent == eAE_MouseWheel
			// short PA_GetMouseWheelIncrement( PA_PluginParameters params )
			break;

	// --- Update and Scroll event
		case eAE_Update :
			QT_DoMovieJob(params);
		break;
			
		case eAE_Scroll :
			QT_DoScroll(params);
				break;

	// --- Select event
		case eAE_Select :
			PA_AcceptSelect( params, 1 );
			break;

	// --- Deselect event
		case eAE_Deselect :
			PA_AcceptDeselect( params, 1 );
			break;

		case eAE_PageChange:
			QT_PageChange(params);
			break;

		case eAE_Idle :
			QT_DoIdle(params);
			break;

#if __NextVersion__      
		case eAE_AreAdvancedPropertiesEditable :
         PA_SetAdvancedPropertiesEditable(params, 1);
         break;

   // We edit the properties
      case eAE_EditAdvancedProperties :
         DesignEditButton(params);
         break;

   // 4D has finish with the properties and has stored them with the form
   // we can now dispose of it.
      case eAE_DisposeAdvancedProperties :
		myptr = PA_GetAdvancedPropertiesToDispose (params);
		if (myptr) free (myptr);
         break;
#endif
	  
	  default  :
			PA_DontTakeEvent( params );
			break;

	}
}


