/*
 *  QTPlayExtern.h
 *  declares routines and variables to be used from outside
 *
 *  Created by Thomas on 22.05.05.
 *  Copyright 2005 4D GmbH. All rights reserved.
 *
 */

#ifndef _TM_QTExtern_
#define _TM_QTExtern_


#if VERSIONWIN
#include <Windows.h>
#else
#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>
#endif

#include "4DPluginAPI.h"


#ifdef __cplusplus
extern "C" {
#endif 
	
	void  QT_Init(void);
	void QT_DeInit(void);

	void QTArea_Init(PA_PluginParameters params);
	void QTArea_PreInit(PA_PluginParameters params);
	void QTArea_DeInit(void * myPtr);

	long PlayFileWithQuickTime (char * pfad, long len);
	void StopPlayFileWithQuickTime(void);

	long QT_SetMovie (void * Area, char * pfad, long len);
	long QT_SetControl (void * Area, long command, long value);
	long QT_GetControl (void * Area, long command, long * value);
	long QT_DoMovieJob(PA_PluginParameters params);
	long QT_DoIdle(PA_PluginParameters params);
	long QT_DoClick(PA_PluginParameters params);
	long QT_DoScroll(PA_PluginParameters params);
	long QT_PageChange(PA_PluginParameters params);

	void DesignEditButton(PA_PluginParameters params);

	void QTArea_Execution(PA_PluginParameters params);
#if __NextVersion__
	long QT_GetID3Tags (void * Area, PA_Variable TagID, PA_Variable TagContent);
#endif


#if VERSIONWIN
	void MyPA_RectToRECT(PA_Rect areaRect, RECT *rect);
#endif


#ifdef __cplusplus
}
#endif 


#endif